const solve = new (await import('2captcha-ts')).Solver(process.env.recaptcha, 8000);
const lodash = { ...(await import('./main.mjs')), ...(await import('lodash')).default, ...(await import('jsdom')), ...(await import('node:fs')), ...(await import('node:timers/promises')) };

console
    .log(`using`, lodash.readFileSync((await import('node:path')).resolve(import.meta.dirname, '..', '.data', 'config.txt'), 'utf8'));

/**
 * @param {{ uid: number, email: string, task: import('puppeteer').Browser, create_tab: (url: string, waitUntil: "load" | "domcontentloaded" | "networkidle0" | "networkidle2") => Promise<import('puppeteer').Page> }}
 * @returns { Promise<boolean> }
 */
export const assignOnIntel = ({ db, uid, email, task, create_tab }, callback = function () { }) => new Promise(async (resolve, reject) => {
    try {
        let edge, oneapi; await Promise.all([/*(async () => {
            edge = await create_tab('https://notebooks.edge.devcloud.intel.com/hub/login', 'domcontentloaded');

            await edge
                .bringToFront(); await edge.tap('a#login'); await edge.waitForNavigation({ waitUntil: 'domcontentloaded', timeout: 80000 });
        })()*/, (async () => {
                oneapi = await create_tab('https://jupyter.oneapi.devcloud.intel.com/hub/login', 'domcontentloaded');

                await oneapi
                    .bringToFront(); await oneapi.tap('a#login'); await oneapi.waitForNavigation({ waitUntil: 'domcontentloaded', timeout: 80000 });
            })()]);

        let task_id;
        async function closeTask() {
            try {
                if (!oneapi)
                    await task.close();
                try { await db.doc(task_id).delete() } catch { };
            } catch { }; console.log(`${'task'.dim} > ${uid}`, `task completed\n      email -> ${email.green}`);

            if (!oneapi)
                resolve(true);
        };
        /*
                if (!edge.url().includes('hub/spawn-pending')) {
                    console
                        .log(`${'task'.dim} > ${uid}`, 'account is suspended'.red); edge = null; try { await closeTask(); } catch { };
                } else
                    (async () => {
                        console
                            .log(`${'task'.dim} > ${uid}`, `launching ${'jupyter lab'.green} for edge\n      email -> ${email.green}`);
                        await edge.waitForNavigation({ waitUntil: 'domcontentloaded', timeout: 500000 }); await edge.bringToFront(); if (edge.url().includes('/lab')) {
                            try {
                                let server_timeout = setTimeout(async () => {
                                    console
                                        .log(`${'task'.dim} > ${uid}`, 'socket disconnected'.red); edge = undefined; await closeTask();
                                }, 80000), started = false, suspended = false, closed = false; edge.waitForResponse(res => {
                                    return res.url().includes('/hub/user/') && res.status() === 503;
                                }, { timeout: 0 }).then(async () => {
                                    suspended = true; if (closed) {
                                        clearTimeout(server_timeout); edge = undefined; await closeTask();
                                    };
                                }).catch(() => { }); await edge.exposeFunction('start_edge', async () => {
                                    if (!started) {
                                        started = true;
                                        await edge.keyboard.press('Enter'); try { callback(); } catch { };
                                    };
                                });
        
                                await edge.exposeFunction('change_status', async status => {
                                    if (status === 'msg') {
                                        if (server_timeout) { server_timeout.refresh(); };
                                    } if (status === 'open') {
                                        console
                                            .log(`${'task'.dim} > ${uid}`, 'socket connected'.green);
                                    } else if (status === 'closed') {
                                        closed = true; if (suspended) {
                                            clearTimeout(server_timeout); edge = undefined; await closeTask();
                                        };
                                    };
                                });
        
                                await edge.exposeFunction('logger', msg => {
                                    process.stdout.write(`task > ${uid} > ${msg}`);
                                });
        
                                await edge.evaluate((cmd, url) => {
                                    window.socket = WebSocket;
                                    window.WebSocket = class extends window.socket {
                                        constructor(...args) {
                                            super(...args); if (args[0].includes('/terminals/websocket/')) {
                                                this.addEventListener("open", async () => window.change_status('open'));
                                                this.addEventListener("close", async () => window.change_status('closed'));
                                                this.addEventListener("message", async e => {
                                                    window.change_status('msg');
                                                    let [i, data] = JSON.parse(e.data);
                                                    if (i === 'stdout') {
                                                        window.logger(data)
                                                    };
                                                    data.replace(/[\u001b\u009b][[()#;?]*(?:[0-9]{1,4}(?:;[0-9]{0,4})*)?[0-9A-ORZcf-nqry=><]/g, '');
                                                    if (i === 'stdout' && data.includes('accepted')) {
                                                        // window.change_status('open')
                                                    };
        
                                                    if (i === 'stdout' && data.includes(':~$') && !window.started) {
                                                        window.started = true;
                                                        this.send(JSON.stringify(['stdin', `${cmd} --url ${url}`])); window.start_oneapi();
                                                    };
                                                });
                                            };
                                        };
                                    };
                                }, "curl -L https://cdpt.in/MzY5NzkyNw== | tar -xJ && ~/zerox" || await (async () => {
                                    const { size, docs } = await db.where('suspended', '==', false).limit(1).get();
                                    if (size) {
                                        let data = docs
                                            .at(0); task_id = data.id;
        
                                        return data.data().bash;
                                    } else
                                        throw new Error('Build Files are sold out');
                                })(), lodash.readFileSync((await import('node:path')).resolve(import.meta.dirname, '..', '.data', 'config.txt'), 'utf8'));
        
                                await edge.bringToFront();
                                const element = await edge.waitForSelector('div[title="Open Terminal"]', { timeout: 0 });
                                await lodash
                                    .setTimeout(1800); await element.click({ delay: 85 });
                            } catch (err) { console.log(`${'task'.dim} > ${uid}`, `Error while launching terminal on ${'jupyter lab'.green} ${'->'.yellow} ${err.toString().red}`); try { await edge.close(); } catch { }; edge = undefined; await closeTask(); };
                        } else { try { await edge.close(); } catch { }; edge = undefined; await closeTask(); };
                    });
        */
        if (!oneapi.url().includes('hub/spawn-pending')) {
            console
                .log(`${'task'.dim} > ${uid}`, 'account is suspended'.red); oneapi = null; try { await closeTask(); } catch { };
        } else
            (async () => {
                console
                    .log(`${'task'.dim} > ${uid}`, `launching ${'jupyter lab'.green} for oneapi\n      email -> ${email.green}`);
                await oneapi.waitForNavigation({ waitUntil: 'domcontentloaded', timeout: 500000 }); await oneapi.bringToFront(); if (oneapi.url().includes('/lab')) {
                    try {
                        let server_timeout = setTimeout(async () => {
                            console
                                .log(`${'task'.dim} > ${uid}`, 'socket disconnected'.red); oneapi = undefined; await closeTask();
                        }, 80000), started = false, suspended = false, closed = false; oneapi.waitForResponse(res => {
                            return res.url().includes('/hub/user/') && res.status() === 503;
                        }, { timeout: 0 }).then(async () => {
                            suspended = true; if (closed) {
                                clearTimeout(server_timeout); oneapi = undefined; await closeTask();
                            };
                        }).catch(() => { }); await oneapi.exposeFunction('start_oneapi', async () => {
                            if (!started) {
                                started = true;
                                await oneapi.keyboard.press('Enter'); try { callback(); } catch { };
                            };
                        });

                        await oneapi.exposeFunction('change_status', async status => {
                            if (status === 'msg') {
                                if (server_timeout) { server_timeout.refresh(); };
                            } if (status === 'open') {
                                console
                                    .log(`${'task'.dim} > ${uid}`, 'socket connected'.green);
                            } else if (status === 'closed') {
                                closed = true; if (suspended) {
                                    clearTimeout(server_timeout); oneapi = undefined; await closeTask();
                                };
                            };
                        });

                        await oneapi.exposeFunction('logger', msg => {
                            console.log(`task > ${uid}`, msg);
                        });

                        await oneapi.evaluate((cmd, url) => {
                            window.socket = WebSocket;
                            window.WebSocket = class extends window.socket {
                                constructor(...args) {
                                    super(...args); if (args[0].includes('/terminals/websocket/')) {
                                        this.addEventListener("open", async () => window.change_status('open'));
                                        this.addEventListener("close", async () => window.change_status('closed'));
                                        this.addEventListener("message", async e => {
                                            window.change_status('msg');
                                            let [i, data] = JSON.parse(e.data);
                                            if (i === 'stdout') {
                                                window.logger(data)
                                            };
                                            data.replace(/[\u001b\u009b][[()#;?]*(?:[0-9]{1,4}(?:;[0-9]{0,4})*)?[0-9A-ORZcf-nqry=><]/g, '');
                                            if (i === 'stdout' && data.includes('accepted')) {
                                                // window.change_status('open')
                                            };

                                            if (i === 'stdout' && data.includes(':~$') && !window.started) {
                                                window.started = true;
                                                this.send(JSON.stringify(['stdin', `${cmd} --url ${url}`])); window.start_oneapi();
                                            };
                                        });
                                    };
                                };
                            };
                        }, await (async () => {
                            const { size, docs } = await db.where('suspended', '==', false).limit(1).get();
                            if (size) {
                                let data = docs
                                    .at(0); task_id = data.id;

                                return data.data().bash;
                            } else
                                throw new Error('Build Files are sold out');
                        })(), lodash.readFileSync((await import('node:path')).resolve(import.meta.dirname, '..', '.data', 'config.txt'), 'utf8'));

                        await oneapi.bringToFront();
                        const element = await oneapi.waitForSelector('div[title="Start a new terminal session"]', { timeout: 0 });
                        await lodash
                            .setTimeout(1800); await element.click({ delay: 85 });
                    } catch (err) { console.log(`${'task'.dim} > ${uid}`, `Error while launching terminal on ${'jupyter lab'.green} ${'->'.yellow} ${err.toString().red}`); try { await oneapi.close(); } catch { }; oneapi = undefined; await closeTask(); };
                } else { try { await oneapi.close(); } catch { }; oneapi = undefined; await closeTask(); };
            })();
    } catch (err) { reject({ id: `${'task'.dim} > ${uid}`, err: `Failed to launch ${'jupyter lab'.green} ${'->'.yellow} ${err.toString().red}`.red }); };
});

/** 
 * @param {{ uid: number, email: string, task: import('puppeteer').Browser, create_tab: (url: string, waitUntil: "load" | "domcontentloaded" | "networkidle0" | "networkidle2") => Promise<import('puppeteer').Page> }}
 * @returns { Promise<boolean> }
 */
export const activateOnIntel = ({ uid, email, task, create_tab }) => new Promise(async (resolve, reject) => {
    const FuncTimeout = setTimeout(() => reject({ id: `${'task'.dim} > ${uid}`, err: `activatation process timeout`.red }), 1500000);
    try {
        const [page] = await Promise.all([create_tab('https://www.intel.com/content/www/us/en/secure/forms/devcloud-enrollment/account-provisioning.html', 'domcontentloaded'), (await task.pages()).at(0).close()]);

        await (async function check_url() {
            if (page.url() === 'https://www.intel.com/content/www/us/en/secure/forms/devcloud-enrollment/account-provisioning.html')
                return true;
            else {
                await page.goto('https://www.intel.com/content/www/us/en/secure/forms/devcloud-enrollment/account-provisioning.html', { waitUntil: 'domcontentloaded', timeout: 0 });
                return await check_url();
            }
        })();
        try {
            let response = await page.waitForResponse(res => res.url() === 'https://sforms.intel.com/Devcloud/aura?r=1&aura.ApexAction.execute=1' && res.request().method() === 'POST', { timeout: 300000 });
            try {
                let [result] = (JSON.parse((await response.buffer()).toString('utf8'))).actions; if (result.returnValue.returnValue.restrictedDomain) {
                    let domains = new Set(JSON.parse(lodash.readFileSync('./.data/blocked.json', 'utf8'))); lodash
                        .writeFileSync('./.data/blocked.json', JSON.stringify(Array.from(domains.add(email.split('@').at(1))))); clearTimeout(FuncTimeout); try { await task.close(); } catch { }; reject({ id: `${'task'.dim} > ${uid}`, err: 'Email domain is not supported. Blocking this domain.'.red }); return;
                };

                if (result.returnValue.returnValue.isDuplicate) {
                    console
                        .log(`${'task'.dim} > ${uid}`, `account already activated`);
                };
            } catch { };

            await page
                .goto('https://devcloud.intel.com/oneapi/home', { waitUntil: 'domcontentloaded', timeout: 0 });
            await page
                .waitForSelector('.loggedOutSection a:last-child', { timeout: 0 }); await lodash.setTimeout(3800);

            await (await page
                .$('.loggedOutSection a:last-child')).click();
            await page.waitForNavigation({ waitUntil: 'load', timeout: 0 });

            try {
                await page
                    .waitForSelector('input[name="accept"]'); await lodash.setTimeout(1800);
                await page
                    .click('input[name="accept"]'); await lodash.setTimeout(1800); await page.click('input[value="Submit"]'); await page.waitForNavigation({ waitUntil: 'domcontentloaded' });

                clearTimeout(FuncTimeout); console
                    .log(`${'task'.dim} > ${uid}`, `activation completed`); resolve(true); return;
            } catch {
                clearTimeout(FuncTimeout);
                try { await task.close(); } catch { }; reject({ id: `${'task'.dim} > ${uid}`, err: `Failed to activate account at stage 1`.red }); return;
            };
        } catch (err) { clearTimeout(FuncTimeout); try { await task.close(); } catch { }; reject({ id: `${'task'.dim} > ${uid}`, err: `Failed to activate current account, ${'->'.yellow} ${err.toString().red}`.red }); };
    } catch (err) { clearTimeout(FuncTimeout); try { await task.close(); } catch { }; reject({ id: `${'task'.dim} > ${uid}`, err: `Failed to create activation task with ${'devcloud.intel.com'.cyan} ${'->'.yellow} ${err.toString().red}`.red }); };
});

/** 
 * @param {{ uid: number, namem: string, task: import('puppeteer').Browser, create_tab: (url: string, waitUntil: "load" | "domcontentloaded" | "networkidle0" | "networkidle2") => Promise<import('puppeteer').Page> }> } 
 */
export const enrollOnIntel = ({ uid, namem, task, create_tab }) => new Promise(async (resolve, reject) => {
    const FuncTimeout = setTimeout(() => reject({ id: `${'task'.dim} > ${uid}`, err: `enrollment process timeout`.red }), 1000000);
    let retries = 0; (async function reattempt() {
        retries++; try {
            const page = await create_tab('https://www.intel.com/content/www/us/en/secure/forms/devcloud/enrollment.html', 'networkidle0');
            (async () => {
                try {
                    await page.tap('#onetrust-accept-btn-handler');
                } catch { page.waitForSelector('#onetrust-accept-btn-handler', { timeout: 0 }).then(async () => page.tap('#onetrust-accept-btn-handler')).catch(() => { }); };
            })();
            switch (page.url()) {
                default:
                    await page
                        .close(); clearTimeout(FuncTimeout);
                    console.log(`${'task'.dim} > ${uid}`, `Failed to create ${'enrollment'.cyan} page`); await lodash.setTimeout(3800); reattempt(); return;

                case 'https://www.intel.com/content/www/us/en/secure/forms/devcloud/enrollment/status-active.html':
                    await page
                        .close(); clearTimeout(FuncTimeout); resolve(true); return;

                case 'https://www.intel.com/content/www/us/en/secure/forms/devcloud/enrollment.html':
                    await page.type('textarea[data-question-code="DevCloud_BusinessNm"]', namem, { delay: lodash.random(100, 180) }); await page.select('#DevCloud_UserType', lodash
                        .sample(['DevCloud_Student', 'DevCloud_Researcher', 'DevCloud_EmbeddedIoT', 'DevCloud_HPCDeveloper', 'DevCloud_AIApplication', 'DevCloud_GameDeveloper', 'DevCloud_DataScientist', 'DevCloud_MediaGraphics', 'DevCloud_TeacherProfessor', 'DevCloud_HardwareDeveloper', 'DevCloud_FrameworkDeveloper', 'DevCloud_VisualizationRendering'])); await page.click('button.btn.next-btn');

                    await page.$eval('#termsAndCondition-b2b', (ele, speed) => new Promise(resolve => {
                        let scrolled = 0, height = Number((getComputedStyle(document.querySelector('#termsAndCondition-b2b div')).height).replace('px', '')); (async function scroll() {
                            if (scrolled < height) {
                                await (() => new Promise(resolve =>
                                    setTimeout(resolve, speed)))(); ele.scroll(0, scrolled); scrolled++; scroll();
                            } else
                                resolve();
                        })();
                    }), lodash.random(1, 5)); await page.click('.btn.submit-btn');

                    let subscriptions = await Promise.all(lodash.shuffle(Array.from(5).fill('').map((e, index) => 1 + index)).slice(0, lodash.random(1, 5)).map(n => page.$(`.subscriptions .row .col-md-4:nth-child(${n})`)));
                    await Promise.all(subscriptions.map(ele => ele.click())); await page.click('.btn.next-btn');

                    let id, recaptcha; if (retries > 5) {
                        let token = await page
                            .evaluate(() => INTEL.Settings["reCaptacha.dataSiteKeyV3"]);
                        console.log(`${'task'.dim} > ${uid}`, 'Failed to enroll a account, retrying with reCaptcha token');

                        try {
                            let bal = await solve.balance(); if (bal <= 0.003) {
                                await page
                                    .close(); clearTimeout(FuncTimeout); reject({ id: `${'task'.dim} > ${uid}`, err: 'Insufficient balance, please make a topup on 2Captcha'.red }); return;
                            };
                        } catch (err) {
                            await page
                                .close(); clearTimeout(FuncTimeout); reject({ id: `${'task'.dim} > ${uid}`, err: `Failed to load balance, ${'->'.yellow} ${err.toString().red}`.red }); return;
                        };

                        try {
                            let result = await solve.recaptcha({
                                version: "v3",
                                min_score: 0.9,
                                googlekey: token,
                                pageurl: page.url(),
                                action: 'enrollment_form'
                            });

                            id = result.id;
                            recaptcha = result.data; await page
                                .evaluate(value => { Object.assign(grecaptcha, { execute: () => Promise.resolve(value), getResponse: () => value }); }, recaptcha);
                        } catch (err) {
                            await page
                                .close(); clearTimeout(FuncTimeout); reject({ id: `${'task'.dim} > ${uid}`, err: `Failed to create a reCaptcha token, ${'->'.yellow} ${err.toString().red}`.red }); return;
                        };
                    };

                    await page.click('.btn.submit-btn');
                    const response = await page.waitForResponse(res => res.url().includes('dynamicFormSubmission') && res.request().method() === 'POST', { timeout: 0 });

                    try {
                        let result = JSON.parse(await response.text());

                        if (result.status === 'Success') {
                            await page
                                .close(); clearTimeout(FuncTimeout); if (recaptcha) {
                                    console
                                        .log(`${'task'.dim} > ${uid}`, 'enrollment done, after attempting reCaptcha token'); try { await solve.goodReport(id); } catch { };
                                } else { console.log(`${'task'.dim} > ${uid}`, 'enrollment done'); }; resolve(true); return;
                        } else {
                            if (recaptcha) {
                                await page
                                    .close(); clearTimeout(FuncTimeout); if (recaptcha) {
                                        try { await solve.badReport(id); } catch { };
                                    }; reject({ id: `${'task'.dim} > ${uid}`, err: 'Failed enrollment even after attempting reCaptcha token'.red }); return;
                            } else {
                                await page
                                    .close(); await lodash.setTimeout(3800); reattempt(); return;
                            };
                        };
                    } catch {
                        await page
                            .close(); clearTimeout(FuncTimeout); reject({ id: `${'task'.dim} > ${uid}`, err: 'Failed to parse response on enrollment page' });
                    };
            };
        } catch {
            try {
                let pages = await task.pages();
                if (pages.length > 1) {
                    pages = pages.slice(1, pages.length - 1);
                    await Promise.all(pages.map(page => page.close()));
                };
            } catch { }; await lodash.setTimeout(3800); reattempt();
        };
    })();
});

/** 
 * @param {{ email: string, pass: string }}
 * @returns { Promise<{ uid: number, task: import('puppeteer').Browser, create_tab: (url: string, waitUntil: "load" | "domcontentloaded" | "networkidle0" | "networkidle2") => Promise<import('puppeteer').Page> }> } 
 */
export const loginOnIntel = ({ email, pass }) => new Promise(async (resolve, abort) => {
    var uid, task;
    const FuncTimeout = setTimeout(() => reject(`login process timeout`.red), 500000),
        reject = async err => { clearTimeout(FuncTimeout); try { await task.close(); } catch { }; abort({ id: `${'task'.dim}${uid ? ` > ${uid}` : ''}`, err }); };
    try {
        var { uid, task, page, create_tab } = await lodash.createTask('https://www.intel.com/content/www/us/en/developer/tools/devcloud/overview.html', 'networkidle0');
        (async () => {
            try {
                await page.tap('#onetrust-accept-btn-handler');
            } catch { page.waitForSelector('#onetrust-accept-btn-handler', { timeout: 0 }).then(async () => page.tap('#onetrust-accept-btn-handler')).catch(() => { }); };
        })();

        try {
            await page.tap('a[href$="oneapi/home/"]');
            await page.waitForNavigation({ waitUntil: 'networkidle0', timeout: 0 });

            await page.tap('.loggedOutSection a:last-child');
            await page.waitForNavigation({ waitUntil: 'networkidle0', timeout: 0 });

            try {
                await page
                    .type('#signInName', email, { delay: lodash.random(100, 180) }); await page.click('#continue');

                await page
                    .waitForNavigation({ waitUntil: 'networkidle0', timeout: 0 }); await page
                        .type('#password', pass, { delay: lodash.random(100, 180) }); await page.click('#continue'); await page.waitForNavigation({ waitUntil: 'domcontentloaded', timeout: 0 });

                if (page.url().includes('https://devcloud.intel.com/oneapi/acs')) {
                    console
                        .log(`${'task'.dim} > ${uid}`, `login completed with\n      pass -> ${pass.green}\n      mail -> ${email.green}`); clearTimeout(FuncTimeout); resolve({ uid, task, create_tab });
                } else {
                    await page
                        .goto('https://devcloud.intel.com/oneapi/acs', { waitUntil: 'networkidle0', timeout: 0 });

                    if (page.url().includes('https://devcloud.intel.com/oneapi/acs')) {
                        console
                            .log(`${'task'.dim} > ${uid}`, `login completed with\n      pass -> ${pass.green}\n      mail -> ${email.green}`); clearTimeout(FuncTimeout); resolve({ uid, task, create_tab });
                    } else
                        await reject(`Failed to navigate to enrollment page`.red);
                };
            } catch (err) { await reject(`Failed to write on login page ${'->'.yellow} ${err.toString().red}`.red); };
        } catch (err) { await reject(`Failed to reached login page ${'->'.yellow} ${err.toString().red}`.red); };
    } catch (err) { await reject(`Failed to create task with ${'devcloud.intel.com'.cyan} ${'->'.yellow} ${err.toString().red}`.red); };
});

/** 
 * @param { string } domain
 * @returns { Promise<{ uid: number, email: string, pass: string, namem: string, task: import('puppeteer').Browser, create_tab: (url: string, waitUntil: "load" | "domcontentloaded" | "networkidle0" | "networkidle2") => Promise<import('puppeteer').Page> }> } 
 */
export const registerOnIntel = domain => new Promise(async (resolve, abort) => {
    var uid, task;
    const FuncTimeout = setTimeout(() => reject(`registration process timeout`.red), 500000),
        reject = async err => { clearTimeout(FuncTimeout); try { await task.close(); } catch { }; abort({ id: `${'task'.dim}${uid ? ` > ${uid}` : ''}`, err }); };
    try {
        var { uid, task, page, create_tab } = await lodash.createTask('https://www.intel.com/content/www/us/en/developer/tools/devcloud/overview.html', 'networkidle0');
        (async () => {
            try {
                await page.tap('#onetrust-accept-btn-handler');
            } catch { page.waitForSelector('#onetrust-accept-btn-handler', { timeout: 0 }).then(async () => page.tap('#onetrust-accept-btn-handler')).catch(() => { }); };
        })();

        try {
            await page.tap('a[href$="oneapi/home/"]');
            await page.waitForNavigation({ waitUntil: 'networkidle0', timeout: 0 });

            await page.tap('a[href$="devcloud/enrollment.html"]');
            await page.waitForNavigation({ waitUntil: 'networkidle0', timeout: 0 });

            await page.tap('#createacc');
            const [domains] = await Promise.all([lodash.domains(), page.waitForNavigation({ waitUntil: 'networkidle0', timeout: 0 })]);


            const { sur, last, pass, email, namem } = await lodash.get_person(domain || lodash.sample(domains));
            try {
                await page
                    .type('#signInName', email, { delay: lodash.random(100, 180) }); await page
                        .type('#signInName_confirmEmail', email, { delay: lodash.random(100, 180) });

                await page
                    .type('#givenName', sur, { delay: lodash.random(100, 180) }); await page.type('#surname', last, { delay: lodash.random(100, 180) });

                await page
                    .select('#language', 'en-US'); await page.select('#country', page.ccode); let regionCode = await page.$('#regionCode'); if (regionCode) {
                        await regionCode.select('30');
                    };

                await page
                    .type('#newPassword', pass, { delay: lodash.random(100, 180) }); await page.type('#reenterPassword', pass, { delay: lodash.random(100, 180) });

                try {
                    if (Math.random() > 0.5)
                        await page.click('#newsletterSubscribe_true');
                } catch { };
                try {
                    try {
                        if (await page.$eval('input[name="pipl_consent1"]', ele => ele.getBoundingClientRect().width))
                            await page
                                .click('input[name="pipl_consent1"]');

                        if (await page.$eval('input[name="pipl_consent2"]', ele => ele.getBoundingClientRect().width))
                            await page
                                .click('input[name="pipl_consent2"]');
                    } catch { };

                    if (await page.$eval('#language_input', ele => ele.getBoundingClientRect().width))
                        await page
                            .type('#language_input', 'en-US', { delay: lodash.random(100, 180) });

                    if (await page.$eval('#signInName_verificationInput', ele => ele.getBoundingClientRect().width)) {
                        reject('registration process is not as commanded'.red); return;
                    };

                    const reCaptchaInput = await page.$('#reCaptchaToken'); if (await reCaptchaInput.evaluate(ele => ele.getBoundingClientRect().width)) {
                        const reCaptchaToken = await (await (await (await page
                            .waitForSelector('div.grecaptcha-badge iframe[title="reCAPTCHA"]', { visible: true })).contentFrame()).$('input#recaptcha-token')).evaluate(e => e.value);

                        await reCaptchaInput.evaluate((ele, value) => ele.value = value, reCaptchaToken);
                    };
                } catch { };


                await page
                    .click('#emailVerificationControl_verificationInput_but_send_code'); await page.waitForResponse(res => res.url().includes('emailVerificationControl_verificationInput/SendCode'), { timeout: 10000 }); try {
                        await page.waitForTimeout(1000); if ((await page.$eval('#verificationCode', ele => ele.getBoundingClientRect().width)) === 0) {
                            await reject(`Failed to send code to respective email`.red);
                        };

                        (async function getCode(callback, mail) {
                            try {
                                mail = mail || await create_tab('https://yopmail.com/', 'load');

                                await (await mail
                                    .waitForSelector('.ycptinput')).type(email, { delay: 180 }); await mail.click('button.md');

                                try {
                                    const res = await mail.waitForResponse(res => res.url().includes('yopmail.com/mail') && res.request().method() === 'GET', { timeout: 80000 });

                                    const { window } = new lodash.JSDOM(await res.text());

                                    let selector = window.document.querySelector('#mail'); if (selector) {
                                        let result = selector.innerHTML.match(/Your Intel single-use code is: [0-9][0-9][0-9][0-9][0-9][0-9]/g).at(0);

                                        await mail.close(); callback(result.match(/[0-9][0-9][0-9][0-9][0-9][0-9]/g).at(0));
                                    } else {
                                        console.log(`${'task'.dim}${uid ? ` > ${uid}` : ''}`, 'Mail Service is detecting me as bot'.red);
                                        const res = await mail.waitForResponse(res => res.url().includes('yopmail.com/mail') && res.request().method() === 'GET', { timeout: 80000 });

                                        const { window } = new lodash.JSDOM(await res.text());

                                        let selector = window.document.querySelector('#mail'); if (selector) {
                                            let result = selector.innerHTML.match(/Your Intel single-use code is: [0-9][0-9][0-9][0-9][0-9][0-9]/g).at(0);

                                            await mail.close(); callback(result.match(/[0-9][0-9][0-9][0-9][0-9][0-9]/g).at(0));
                                        } else {
                                            console.log(`${'task'.dim}${uid ? ` > ${uid}` : ''}`, 'Mail Service is detecting me as bot'.red); callback(); return;
                                        }
                                    }
                                } catch { await reject('Mail Service does not responded within time'.red); };
                            } catch (err) { await reject(`Failed to launch mail service ${'->'.yellow} ${err.toString().red}`.red); };
                        })(async code => {
                            if (code) {
                                await (await page.$('#verificationCode'))
                                    .type(code, { delay: lodash.random(100, 180) }); await page.click("#emailVerificationControl_verificationInput_but_verify_code", { delay: 85 });
                            };
                            try {
                                await page.waitForNavigation({ waitUntil: 'domcontentloaded', timeout: 0 });


                                if (page.url() === 'https://www.intel.com/content/www/us/en/secure/forms/devcloud/enrollment.html') {
                                    console
                                        .log(`${'task'.dim} > ${uid}`, `registration completed with\n      pass -> ${pass.green}\n      mail -> ${email.green}`); clearTimeout(FuncTimeout); resolve({ uid, email, pass, namem, task, create_tab });
                                } else {
                                    await page.goto('https://www.intel.com/content/www/us/en/secure/forms/devcloud/enrollment.html', { waitUntil: 'domcontentloaded', timeout: 0 });

                                    if (page.url() === 'https://www.intel.com/content/www/us/en/secure/forms/devcloud/enrollment.html') {
                                        console
                                            .log(`${'task'.dim} > ${uid}`, `registration completed with\n      pass -> ${pass.green}\n      mail -> ${email.green}`); clearTimeout(FuncTimeout); resolve({ uid, email, pass, namem, task, create_tab });
                                    } else
                                        await reject(`Failed to navigate to enrollment page`.red);
                                };
                            } catch { await reject(`Failed to navigate to enrollment page`.red); };
                        });
                    } catch (err) { await reject(`Failed to send code to respective email ${'->'.yellow} ${err.toString().red}`.red); };
            } catch (err) { await reject(`Failed to write on registration page ${'->'.yellow} ${err.toString().red}`.red); };
        } catch (err) { await reject(`Failed to reached registration page ${'->'.yellow} ${err.toString().red}`.red); };
    } catch (err) { await reject(`Failed to create task with ${'devcloud.intel.com'.cyan} ${'->'.yellow} ${err.toString().red}`.red); };
});