import axios from 'axios';
import jsdom from 'jsdom';
import lodash from 'lodash';

let task_id = 1;
export const userAgent = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:120.0) Gecko/20100101 Firefox/120.0';
/** 
 * @param { string } url 
 * @param { "load" | "domcontentloaded" | "networkidle0" | "networkidle2" } waitUntil
 */
export const createTask = async (url, waitUntil) => {
    console.log('task'.dim, 'lauching new instance with uid ' + task_id); let id = task_id; task_id++; let auth = { password: 'anyosubhas', username: `subhasweb-${id}` }; if (task_id > 10)
        task_id = 1;
    const [task, { data }] = await Promise.all([
        await ((await import('puppeteer-extra')).default)
            .use((await import('puppeteer-extra-plugin-stealth')).default())
            .use((await import('puppeteer-extra-plugin-recaptcha')).default({ throwOnError: true })).launch({
                product: 'chrome', protocolTimeout: 0, headless: false, defaultViewport: { width: 1300, height: 800, isMobile: false, hasTouch: false },
                ignoreDefaultArgs: ['--disable-blink-features=AutomationControlled'], args: [
                    '--mute-audio',
                    '--enable-webgl',
                    '--no-first-run',
                    '--lang=en-US,en',
                    '--hide-scrollbars',
                    '--disable-infobars',
                    '--disable-extensions',
                    '--window-position=5,5',
                    '--window-size=1325,903',
                    '--disable-notifications',
                    '--proxy-server=p.webshare.io:80',
                    '--disk-cache-dir=G:/Bot.AI/.data/.cache',
                    '--disable-features=TranslateUI,BlinkGenPropertyTrees',
                ]
            }),
        { data: { city: 'Washington', country: 'US' } } || await axios.get('https://ipinfo.io/json', { proxy: { host: 'p.webshare.io', port: 80, protocol: 'http', auth } })
    ]);

    /**
     * @param { string } url 
     * @param { "load" | "domcontentloaded" | "networkidle0" | "networkidle2" } waitUntil
     */
    const create_tab = async (url, waitUntil) => {
        const page = await task.newPage();
        await page.setUserAgent(userAgent); await page.authenticate(auth);
        /*
                await page.setRequestInterception(true); page.on('request', async req => {
                    switch (req.resourceType()) {
                        case 'font':
                        case 'image':
                        case 'script':
                        case 'document':
                        case 'stylesheet':
                            if (req.method() === 'GET') {
                                const url = new URL(req.url());
                                if (url.search.length > 0) {
                                    await req
                                        .continue(); return;
                                };
                                const origin = Buffer.from(url.origin, 'utf8').toString('base64url');
                                const pathname = Buffer.from(url.pathname, 'utf8').toString('base64url');
        
                                if (!fs.existsSync(`./.data/.cache/${origin}`))
                                    fs.mkdirSync(`./.data/.cache/${origin}`);
        
                                if (fs.existsSync(`./.data/.cache/${origin}/${pathname}.json`)) {
                                    try {
                                        const { headers, data } = JSON.parse(fs.readFileSync(`./.data/.cache/${origin}/${pathname}.json`, 'utf8'));
        
                                        await req.respond({
                                            body: data,
                                            status: 200,
                                            headers: headers,
                                            contentType: headers['Content-Type']
                                        }); return;
                                    } catch {
                                        await req
                                            .continue(); return;
                                    };
                                } else {
                                    try {
                                        const { headers, data } = await axios.get(url.toString(), { headers: req.headers(), proxy: { protocol: 'http', host: 'p.webshare.io', port: 80, auth } });
        
                                        fs.writeFileSync(`./.data/.cache/${origin}/${pathname}.json`, JSON.stringify({ headers, data }));
        
                                        await req.respond({
                                            body: data,
                                            status: 200,
                                            headers: headers,
                                            contentType: headers['Content-Type']
                                        }); return;
                                    } catch {
                                        await req
                                            .continue(); return;
                                    };
                                };
                            } else
                                await req
                                    .continue(); return;
        
                        default:
                            await req
                                .continue(); return;
                    };
                });
        */
        await page.goto(url, { waitUntil, timeout: 0 });

        return Object.assign(page, {
            ccode: data.country, log: (...msgs) => console.log(`${'task'.dim} > ${id - 1}`, ...msgs), waitForTimeout: (await import('timers/promises')).setTimeout,

            tap: async (selector = 'html') => {
                let ele = await page.$(selector);
                ele = ele ? ele : await page.waitForSelector(selector);

                await page
                    .waitForTimeout(lodash.random(300, 800)); return await ele.evaluate(async ele => await ele.click());
            },
            select: async (selector = 'html', value = '') => {
                let ele = await page.$(selector);
                ele ? ele : await page.waitForSelector(selector, { visible: true }); return await ele.select(value);
            },
            setValue: async (selector = 'html', value = '') => {
                let speed = lodash.random(80, 180), ele = await page.$(selector);

                ele = ele ? ele : await page
                    .waitForSelector(selector, { visible: true }); return await ele.evaluate(async (ele, value, speed) => {
                        for (let v of value)
                            await (async () => { await new Promise(resolve => setTimeout(resolve, speed)); ele.value += v; })();

                        return value.join('');
                    }, value.split(''), speed);
            }
        });
    };

    try {
        const [page] = await Promise.all([create_tab(url, waitUntil || 'networkidle0'), (await task.pages()).at(0).close()]);

        console
            .log(`${'task'.dim} > ${id}`, `launched a new instance with\n      region -> ${`${data.city}, ${data.country}`.cyan}\n      address -> ${url.cyan}`); return { uid: id, auth, task, page, create_tab };
    } catch (err) {
        try { await task.close(); } catch { }; throw err;
    };
};

const { person, internet, company } = (await import('@faker-js/faker')).faker;
/** @param {string} domain */ export const get_person = async domain => {
    const gender = person
        .gender(); const sur = person.firstName(gender).replace("'", '-'), last = person.lastName(gender).replace("'", '-');

    return {
        sur, last, pass: internet.password({ length: lodash.random(8, 18), prefix: '@8aA' })
            .split('').sort(() => Math.random() - 0.5).join(''), email: `${sur.toLocaleLowerCase()}.${last.toLocaleLowerCase()}_${lodash.random(1000, 10000)}@${domain}`, namem: company.name()
    };
};

/** @returns { Promise<Array<string>> } */ export const domains = () => new Promise(async (resolve, reject) => {
    try {
        const { window } = new jsdom.JSDOM((await axios.get('https://yopmail.com/domain?d=all', {
            headers: { "User-Agent": userAgent }, proxy: {
                port: 80, host: 'p.webshare.io',
                protocol: 'http', auth: { username: 'subhasweb-rotate', password: 'anyosubhas' }
            }
        })).data);

        let result = Array.from(window.document.querySelectorAll('.lstdom div')).map(div => div.innerHTML).map(domain => domain.slice(1));

        let blocked = new Set(JSON.parse(await (await import('fs/promises'))
            .readFile('./.data/blocked.json', 'utf8'))); resolve(result.filter(domain => !blocked.has(domain)));
    } catch (err) { reject(`Failed to parse document ${'->'.yellow} ${err.stack.red}`.red); };
});